import org.omg.CORBA.*;

public class ClienteCORBA_DII 
{
    public static void main(String[] args)
    {
        try {
            // Inicializar el ORB
            ORB orb = ORB.init(args,null);

            // Obtener una referencia al objeto a partir del IOR
            org.omg.CORBA.Object obj = orb.string_to_object( args[0] );
            
            // Crear la peticin al objeto `obj'
            Request req = obj._request("open");
            
            // Establecer el tipo devuelto
            req.set_return_type(Bank.AccountHelper.type());
            
            // Establecer los argumentos
            org.omg.CORBA.Any nombre = req.add_in_arg();
            nombre.insert_string( args[1] );
            
            // Invocar la operacin
            req.invoke();

            // Tener en cuenta si se ha lanzado alguna excepcin
            java.lang.Exception ex = req.env().exception();
            if (ex != null)
            {
                throw (org.omg.CORBA.SystemException) ex;
            }

            // Obtener la cuenta del cliente pasado como parmetro
            Bank.Account acc;
            acc = Bank.AccountHelper.extract( req.return_value() );

            // Pedir el balance de la cuenta obtenida
            float balance = acc.balance();

            System.out.println("Cliente: " + args[1]);
            System.out.println("Balance: " + balance);
        }
        catch (SystemException e)
        {
            System.err.println(e);
        }
    }
}
