# -*- Python -*-

from Fnorb.orb import CORBA,BOA

import Bank
import Bank_skel

from time import time
from random import randint

from AccountImpl import *

class AccountManagerImpl(Bank_skel.AccountManager_skel):

    # Constructor
    def __init__(self):
        # Llamar al constructor de la clase base
        CORBA.Object_skel.__init__(self)
        self._accounts = {}
        
    # Implementar operaciones
    def open(self, name):
        """ Implementa el mtodo Bank/AccountManager/open """

        # Ver si el cliente ya se ha creado
        if self._accounts.has_key(name):
            return self._accounts[name]

        # No se ha creado, crear
        acc = AccountImpl( randint(0,10000) / 100.0 )
        boa = BOA.BOA_init()
        ref = boa.create('dsr2',AccountImpl._FNORB_ID)
        boa.obj_is_ready( ref, acc )

        # Y aadirlo al diccionario local (o a la base de datos)
        self._accounts[name] = acc
        return acc

