//***********************************************************
// ChatApplet.java:	Applet
//
//***********************************************************
import java.applet.*;
import java.awt.*;
import java.net.*;
import java.io.*;

//===========================================================
// Main Class for applet ChatApplet
//
//===========================================================
public class ChatApplet extends Applet implements Runnable
{
	// THREAD SUPPORT:
	//	m_ChatApplet	is the Thread object for the applet
	//---------------------------------------------------
	Thread	 m_ChatApplet = null;

	// Applet data
	private TextField nameField;
	private TextArea chatZone;
	private TextField text;
	private Socket socket = null;
	private BufferedInputStream istream;
	private BufferedOutputStream ostream;

	private static int MAX_LEN = 500;

	// PARAMETER SUPPORT:
	//		Parameters allow an HTML author to pass 
	// information to the applet; the HTML author specifies them 
	// using the <PARAM> tag within the <APPLET> tag.  The 
	// following variables are used to store the values of the
	// parameters.
	//------------------------------------------------------

	// Members for applet parameters
	// <type>       <MemberVar>    = <Default Value>
	//------------------------------------------------------
	private String m_direccion = "155.54.12.32";

	// Parameter names.  To change a name of a parameter, 
	// you need only make a single change.  Simply modify the 
	// value of the parameter string below.
	//------------------------------------------------------
	private final String PARAM_direccion = "direccion";

	// ChatApplet Class Constructor
	//------------------------------------------------------
	public ChatApplet()
	{
		// TODO: Add constructor code here
	}

	// APPLET INFO SUPPORT:
	//		The getAppletInfo() method returns a string 
	// describing the applet's author, copyright date, 
	// or miscellaneous information.
	//---------------------------------------------------------
	public String getAppletInfo()
	{
		return "Name: ChatApplet\r\n" +
		       "Author: Diego\r\n" +
		       "Created with Microsoft Visual J++ Version 1.0";
	}

	// PARAMETER SUPPORT
	//		The getParameterInfo() method returns an array 
	// of strings describing the parameters understood by this applet.
	//
	// ChatApplet Parameter Information:
	//  { "Name", "Type", "Description" },
	//---------------------------------------------------------
	public String[][] getParameterInfo()
	{
		String[][] info =
		{
			{ PARAM_direccion, "String","Parameter description" },
		};
		return info;
	}

	// The init() method is called by the AWT when an applet 
	// is first loaded or reloaded.  Override this method to 
	// perform whatever initialization your applet needs, such 
	// as initializing data structures, loading images or
	// fonts, creating frame windows, setting the layout manager, 
	// or adding UI components.
	//---------------------------------------------------------
	public void init()
	{
		// PARAMETER SUPPORT
		//		The following code retrieves the value 
		// of each parameter specified with the <PARAM> tag and 
		// stores it in a member variable.
		//---------------------------------------------------
		String param;

		// direccion: Parameter description
		//--------------------------------------------------
		param = getParameter(PARAM_direccion);
		if (param != null)
			m_direccion = param;

        // If you use a ResourceWizard-generated "control creator" 
        // class to arrange controls in your applet, you may want 
        // to call its CreateControls() method from within this
        // method. Remove the following call to resize() before 
        // adding the call to CreateControls();
        // CreateControls() does its own resizing.
        //---------------------------------------------------------
		resize(600, 300);

		// TODO: Place additional initialization code here

		// Esto va a ser duro, pero...
		GridBagLayout gb = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		setLayout(gb);

		// Poner Nombre: ________
		c.fill = GridBagConstraints.BOTH;
		c.weightx = 1.0;
		c.weighty = 1.0;
		Label l = new Label("Nombre:",Label.RIGHT);
		gb.setConstraints(l,c);
		add(l);

		c.gridwidth = GridBagConstraints.REMAINDER;
		nameField = new TextField("Pon tu nombre!");
		gb.setConstraints(nameField,c);
		add(nameField);

		// Ultimo de la lnea: un TextArea que ocupa cuatro filas
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.gridheight = 8;
		chatZone = new TextArea();
		gb.setConstraints(chatZone,c);
		add(chatZone);

		// El texto que escribes
		c.gridheight = 1;
		text = new TextField();
		gb.setConstraints(text,c);
		add(text);

		//////////////////
		// Establecer la conexin
		try
		{
			socket = new Socket(m_direccion,9000);

			ostream = new BufferedOutputStream(
					socket.getOutputStream());
			istream = new BufferedInputStream(
					socket.getInputStream());
		} catch (Exception e)
		{
			showStatus("Error: "+e);
			chatZone.appendText(
			    "Error estableciendo la comunicacin. Sorry!\r\n");
		}

	}

	// Place additional applet clean up code here.  destroy() 
	// is called when you applet is terminating and being unloaded.
	//------------------------------------------------------------
	public void destroy()
	{
		// TODO: Place applet cleanup code here
	}

	//		The start() method is called when the page 
	// containing the applet first appears on the screen. The 
	// AppletWizard's initial implementation of this method 
	// starts execution of the applet's thread.
	//---------------------------------------------------------
	public void start()
	{
		if (m_ChatApplet == null)
		{
			m_ChatApplet = new Thread(this);
			m_ChatApplet.start();
		}
		// TODO: Place additional applet start code here
	}

	//		The stop() method is called when the page 
	// containing the applet is no longer on the screen. The 
	// AppletWizard's initial implementation of this method 
	// stops execution of the applet's thread.
	//--------------------------------------------------------
	public void stop()
	{
		if (m_ChatApplet != null)
		{
			m_ChatApplet.stop();
			m_ChatApplet = null;
		}

		try 
		{
			if (socket != null) 
				socket.close();
			socket = null;
		}
		catch(Exception e)
		{}
	}

	// THREAD SUPPORT
	//		The run() method is called when the applet's 
	// thread is started. If your applet performs any ongoing 
	// activities without waiting for user input, the code for 
	// implementing that behavior typically goes here. For
	// example, for an applet that performs animation, the run() 
	// method controls the display of images.
	//--------------------------------------------------------
	public void run()
	{
		byte[] buffer = new byte[MAX_LEN];
		int bytesRead;
		String msg;

		nameField.selectAll();

		if (socket != null)
		{
			try
			{
				bytesRead = istream.read(buffer,0,MAX_LEN);
				while (bytesRead != -1)
				{
					msg = new String(buffer,0,0,bytesRead);
					chatZone.appendText(msg);

					bytesRead = istream.read(buffer,0,MAX_LEN);
				}

				chatZone.appendText(
				    "\r\n Conexin cortada por el servidor !!!\r\n");
				socket.close();
			} catch (Exception e)
			{
				showStatus("Error: " +e);
			}
		}
	}


	public boolean handleEvent(Event ev)
	{
		// Si en el cuadro de texto
		if (ev.target == text)
		{
			// Se ha pulsado una tecla
			if (ev.id == Event.KEY_PRESS)
				// Y es ENTER...
				if (ev.key == 0xa)
				{
					sendToServer(nameField.getText() +
					    "> " + text.getText() + "\r\n");
					text.setText("");
					return true;
				}
		}

		return false;
	}


	private synchronized void sendToServer(String texto)
	{
		byte[] buffer = new byte[MAX_LEN];

		if (socket != null)
		{
			texto.getBytes(0,texto.length(),buffer,0);
			try {
				ostream.write(buffer,0,texto.length());
				ostream.flush();
			} catch (IOException e)
			{
				showStatus("Error mientras se escriba");
			}
		}
	}
}
